use clap::{Parser, Subcommand};
fn main() {
    common::entrypoint(program);
}

#[derive(Parser, Debug)]
#[command(version, about, long_about = None)]
pub struct Args {
    #[command(subcommand)]
    pub command: Commands,
}

#[derive(Debug, Subcommand)]
pub enum Commands {
    /// Configures the ipv6 address using instance metadata and iproute2
    Configure,
}

fn program() -> anyhow::Result<()> {
    let args = Args::parse();
    match args.command {
        Commands::Configure => configure(),
    }
}

fn configure() -> anyhow::Result<()> {
    Ok(())
}
